> For clean Markdown of any page, append .md to the page URL.
> For a complete documentation index, see https://docs.tester.army/llms.txt.
> For full documentation content, see https://docs.tester.army/llms-full.txt.
> For AI client integration (Claude Code, Cursor, etc.), connect to the MCP server at https://docs.tester.army/_mcp/server.

# Trigger a dynamic pull request run

POST https://tester.army/api/v1/projects/{projectId}/pull-request-runs
Content-Type: application/json

Trigger the dynamic PR agent from CI using PR metadata. Callers do not send changed files; TesterArmy enriches with changed files and GitHub reporting only when the project has a supported GitHub connection.

Reference: https://docs.tester.army/api-reference/tester-army-api/projects/trigger-a-dynamic-pull-request-run

## OpenAPI Specification

```yaml
openapi: 3.1.0
info:
  title: testerarmy
  version: 1.0.0
paths:
  /v1/projects/{projectId}/pull-request-runs:
    post:
      operationId: trigger-a-dynamic-pull-request-run
      summary: Trigger a dynamic pull request run
      description: >-
        Trigger the dynamic PR agent from CI using PR metadata. Callers do not
        send changed files; TesterArmy enriches with changed files and GitHub
        reporting only when the project has a supported GitHub connection.
      tags:
        - subpackage_projects
      parameters:
        - name: projectId
          in: path
          description: Project ID or shortId
          required: true
          schema:
            type: string
        - name: Authorization
          in: header
          description: API key authentication using Bearer token format
          required: true
          schema:
            type: string
      responses:
        '202':
          description: Dynamic PR run queued successfully
          content:
            application/json:
              schema:
                $ref: >-
                  #/components/schemas/Projects_triggerADynamicPullRequestRun_Response_202
        '400':
          description: Bad Request - Invalid input parameters
          content:
            application/json:
              schema:
                $ref: >-
                  #/components/schemas/TriggerADynamicPullRequestRunRequestBadRequestError
        '401':
          description: Unauthorized - Invalid or missing API key
          content:
            application/json:
              schema:
                $ref: >-
                  #/components/schemas/TriggerADynamicPullRequestRunRequestUnauthorizedError
        '404':
          description: Project not found
          content:
            application/json:
              schema:
                $ref: >-
                  #/components/schemas/TriggerADynamicPullRequestRunRequestNotFoundError
        '413':
          description: Request body too large
          content:
            application/json:
              schema:
                $ref: >-
                  #/components/schemas/TriggerADynamicPullRequestRunRequestContentTooLargeError
        '429':
          description: Too Many Requests - Usage limit exceeded
          content:
            application/json:
              schema:
                $ref: >-
                  #/components/schemas/TriggerADynamicPullRequestRunRequestTooManyRequestsError
        '500':
          description: Internal Server Error
          content:
            application/json:
              schema:
                $ref: >-
                  #/components/schemas/TriggerADynamicPullRequestRunRequestInternalServerError
        '504':
          description: Gateway Timeout - Test execution exceeded time limit
          content:
            application/json:
              schema:
                $ref: >-
                  #/components/schemas/TriggerADynamicPullRequestRunRequestGatewayTimeoutError
      requestBody:
        content:
          application/json:
            schema:
              $ref: '#/components/schemas/DynamicPrRunRequest'
servers:
  - url: https://tester.army/api
components:
  schemas:
    DynamicPrRunRequestOneOf0Platform:
      type: string
      enum:
        - web
      title: DynamicPrRunRequestOneOf0Platform
    DynamicPrRunRequestOneOf0PullRequestProvider:
      type: string
      enum:
        - github
      default: github
      title: DynamicPrRunRequestOneOf0PullRequestProvider
    DynamicPrRunRequestOneOf0PullRequest:
      type: object
      properties:
        provider:
          $ref: '#/components/schemas/DynamicPrRunRequestOneOf0PullRequestProvider'
        number:
          type: integer
        title:
          type: string
        description:
          type: string
        baseBranch:
          type: string
        headBranch:
          type: string
        commitSha:
          type: string
      required:
        - number
        - title
        - commitSha
      title: DynamicPrRunRequestOneOf0PullRequest
    DynamicPrRunRequest0:
      type: object
      properties:
        targetUrl:
          type: string
          format: uri
        platform:
          $ref: '#/components/schemas/DynamicPrRunRequestOneOf0Platform'
        pullRequest:
          $ref: '#/components/schemas/DynamicPrRunRequestOneOf0PullRequest'
      required:
        - targetUrl
        - pullRequest
      title: DynamicPrRunRequest0
    DynamicPrRunRequestOneOf1Platform:
      type: string
      enum:
        - ios
        - android
      title: DynamicPrRunRequestOneOf1Platform
    DynamicPrRunRequestOneOf1PullRequestProvider:
      type: string
      enum:
        - github
      default: github
      title: DynamicPrRunRequestOneOf1PullRequestProvider
    DynamicPrRunRequestOneOf1PullRequest:
      type: object
      properties:
        provider:
          $ref: '#/components/schemas/DynamicPrRunRequestOneOf1PullRequestProvider'
        number:
          type: integer
        title:
          type: string
        description:
          type: string
        baseBranch:
          type: string
        headBranch:
          type: string
        commitSha:
          type: string
      required:
        - number
        - title
        - commitSha
      title: DynamicPrRunRequestOneOf1PullRequest
    DynamicPrRunRequestOneOf1Mobile:
      type: object
      properties:
        appId:
          type: string
          format: uuid
        bundleId:
          type: string
        artifactUrl:
          type: string
          format: uri
        artifactFilename:
          type: string
        buildId:
          type: string
      title: DynamicPrRunRequestOneOf1Mobile
    DynamicPrRunRequestOneOf1SimulatorRegion:
      type: string
      enum:
        - eu-north1
        - us-west1
      title: DynamicPrRunRequestOneOf1SimulatorRegion
    DynamicPrRunRequest1:
      type: object
      properties:
        platform:
          $ref: '#/components/schemas/DynamicPrRunRequestOneOf1Platform'
        pullRequest:
          $ref: '#/components/schemas/DynamicPrRunRequestOneOf1PullRequest'
        mobile:
          $ref: '#/components/schemas/DynamicPrRunRequestOneOf1Mobile'
        simulatorRegion:
          $ref: '#/components/schemas/DynamicPrRunRequestOneOf1SimulatorRegion'
      required:
        - platform
        - pullRequest
      title: DynamicPrRunRequest1
    DynamicPrRunRequest:
      oneOf:
        - $ref: '#/components/schemas/DynamicPrRunRequest0'
        - $ref: '#/components/schemas/DynamicPrRunRequest1'
      title: DynamicPrRunRequest
    V1ProjectsProjectIdPullRequestRunsPostResponsesContentApplicationJsonSchemaStatus:
      type: string
      enum:
        - queued
      title: >-
        V1ProjectsProjectIdPullRequestRunsPostResponsesContentApplicationJsonSchemaStatus
    V1ProjectsProjectIdPullRequestRunsPostResponsesContentApplicationJsonSchemaPlatform:
      type: string
      enum:
        - web
        - ios
        - android
      title: >-
        V1ProjectsProjectIdPullRequestRunsPostResponsesContentApplicationJsonSchemaPlatform
    V1ProjectsProjectIdPullRequestRunsPostResponsesContentApplicationJsonSchemaMetadataGithubStatus:
      type: string
      enum:
        - not_configured
        - check_create_failed
        - pr_not_found
      title: >-
        V1ProjectsProjectIdPullRequestRunsPostResponsesContentApplicationJsonSchemaMetadataGithubStatus
    V1ProjectsProjectIdPullRequestRunsPostResponsesContentApplicationJsonSchemaMetadataGithub:
      type: object
      properties:
        configured:
          type: boolean
        checkRunCreated:
          type: boolean
        commentTargetResolved:
          type: boolean
        status:
          $ref: >-
            #/components/schemas/V1ProjectsProjectIdPullRequestRunsPostResponsesContentApplicationJsonSchemaMetadataGithubStatus
      required:
        - configured
        - checkRunCreated
        - commentTargetResolved
      title: >-
        V1ProjectsProjectIdPullRequestRunsPostResponsesContentApplicationJsonSchemaMetadataGithub
    V1ProjectsProjectIdPullRequestRunsPostResponsesContentApplicationJsonSchemaMetadataMobile:
      type: object
      properties:
        source:
          type: string
        buildId:
          type: string
      required:
        - source
      title: >-
        V1ProjectsProjectIdPullRequestRunsPostResponsesContentApplicationJsonSchemaMetadataMobile
    V1ProjectsProjectIdPullRequestRunsPostResponsesContentApplicationJsonSchemaMetadata:
      type: object
      properties:
        github:
          $ref: >-
            #/components/schemas/V1ProjectsProjectIdPullRequestRunsPostResponsesContentApplicationJsonSchemaMetadataGithub
        mobile:
          $ref: >-
            #/components/schemas/V1ProjectsProjectIdPullRequestRunsPostResponsesContentApplicationJsonSchemaMetadataMobile
      title: >-
        V1ProjectsProjectIdPullRequestRunsPostResponsesContentApplicationJsonSchemaMetadata
    Projects_triggerADynamicPullRequestRun_Response_202:
      type: object
      properties:
        status:
          $ref: >-
            #/components/schemas/V1ProjectsProjectIdPullRequestRunsPostResponsesContentApplicationJsonSchemaStatus
        runId:
          type: string
          format: uuid
        projectId:
          type: string
          format: uuid
        platform:
          $ref: >-
            #/components/schemas/V1ProjectsProjectIdPullRequestRunsPostResponsesContentApplicationJsonSchemaPlatform
        metadata:
          $ref: >-
            #/components/schemas/V1ProjectsProjectIdPullRequestRunsPostResponsesContentApplicationJsonSchemaMetadata
      required:
        - status
        - runId
        - projectId
        - platform
      title: Projects_triggerADynamicPullRequestRun_Response_202
    TriggerADynamicPullRequestRunRequestBadRequestError:
      type: object
      properties:
        error:
          type: string
          description: Error code or type
        message:
          type: string
          description: Human-readable error message
      required:
        - error
        - message
      title: TriggerADynamicPullRequestRunRequestBadRequestError
    TriggerADynamicPullRequestRunRequestUnauthorizedError:
      type: object
      properties:
        error:
          type: string
          description: Error code or type
        message:
          type: string
          description: Human-readable error message
      required:
        - error
        - message
      title: TriggerADynamicPullRequestRunRequestUnauthorizedError
    TriggerADynamicPullRequestRunRequestNotFoundError:
      type: object
      properties:
        error:
          type: string
          description: Error code or type
        message:
          type: string
          description: Human-readable error message
      required:
        - error
        - message
      title: TriggerADynamicPullRequestRunRequestNotFoundError
    TriggerADynamicPullRequestRunRequestContentTooLargeError:
      type: object
      properties:
        error:
          type: string
          description: Error code or type
        message:
          type: string
          description: Human-readable error message
      required:
        - error
        - message
      title: TriggerADynamicPullRequestRunRequestContentTooLargeError
    TriggerADynamicPullRequestRunRequestTooManyRequestsError:
      type: object
      properties:
        error:
          type: string
          description: Error code or type
        message:
          type: string
          description: Human-readable error message
      required:
        - error
        - message
      title: TriggerADynamicPullRequestRunRequestTooManyRequestsError
    TriggerADynamicPullRequestRunRequestInternalServerError:
      type: object
      properties:
        error:
          type: string
          description: Error code or type
        message:
          type: string
          description: Human-readable error message
      required:
        - error
        - message
      title: TriggerADynamicPullRequestRunRequestInternalServerError
    TriggerADynamicPullRequestRunRequestGatewayTimeoutError:
      type: object
      properties:
        error:
          type: string
          description: Error code or type
        message:
          type: string
          description: Human-readable error message
      required:
        - error
        - message
      title: TriggerADynamicPullRequestRunRequestGatewayTimeoutError
  securitySchemes:
    bearerAuth:
      type: http
      scheme: bearer
      description: API key authentication using Bearer token format

```

## SDK Code Examples

```python
import requests

url = "https://tester.army/api/v1/projects/projectId/pull-request-runs"

payload = {
    "targetUrl": "string",
    "pullRequest": {
        "number": 1,
        "title": "string",
        "commitSha": "string"
    }
}
headers = {
    "Authorization": "Bearer <token>",
    "Content-Type": "application/json"
}

response = requests.post(url, json=payload, headers=headers)

print(response.json())
```

```javascript
const url = 'https://tester.army/api/v1/projects/projectId/pull-request-runs';
const options = {
  method: 'POST',
  headers: {Authorization: 'Bearer <token>', 'Content-Type': 'application/json'},
  body: '{"targetUrl":"string","pullRequest":{"number":1,"title":"string","commitSha":"string"}}'
};

try {
  const response = await fetch(url, options);
  const data = await response.json();
  console.log(data);
} catch (error) {
  console.error(error);
}
```

```go
package main

import (
	"fmt"
	"strings"
	"net/http"
	"io"
)

func main() {

	url := "https://tester.army/api/v1/projects/projectId/pull-request-runs"

	payload := strings.NewReader("{\n  \"targetUrl\": \"string\",\n  \"pullRequest\": {\n    \"number\": 1,\n    \"title\": \"string\",\n    \"commitSha\": \"string\"\n  }\n}")

	req, _ := http.NewRequest("POST", url, payload)

	req.Header.Add("Authorization", "Bearer <token>")
	req.Header.Add("Content-Type", "application/json")

	res, _ := http.DefaultClient.Do(req)

	defer res.Body.Close()
	body, _ := io.ReadAll(res.Body)

	fmt.Println(res)
	fmt.Println(string(body))

}
```

```ruby
require 'uri'
require 'net/http'

url = URI("https://tester.army/api/v1/projects/projectId/pull-request-runs")

http = Net::HTTP.new(url.host, url.port)
http.use_ssl = true

request = Net::HTTP::Post.new(url)
request["Authorization"] = 'Bearer <token>'
request["Content-Type"] = 'application/json'
request.body = "{\n  \"targetUrl\": \"string\",\n  \"pullRequest\": {\n    \"number\": 1,\n    \"title\": \"string\",\n    \"commitSha\": \"string\"\n  }\n}"

response = http.request(request)
puts response.read_body
```

```java
import com.mashape.unirest.http.HttpResponse;
import com.mashape.unirest.http.Unirest;

HttpResponse<String> response = Unirest.post("https://tester.army/api/v1/projects/projectId/pull-request-runs")
  .header("Authorization", "Bearer <token>")
  .header("Content-Type", "application/json")
  .body("{\n  \"targetUrl\": \"string\",\n  \"pullRequest\": {\n    \"number\": 1,\n    \"title\": \"string\",\n    \"commitSha\": \"string\"\n  }\n}")
  .asString();
```

```php
<?php
require_once('vendor/autoload.php');

$client = new \GuzzleHttp\Client();

$response = $client->request('POST', 'https://tester.army/api/v1/projects/projectId/pull-request-runs', [
  'body' => '{
  "targetUrl": "string",
  "pullRequest": {
    "number": 1,
    "title": "string",
    "commitSha": "string"
  }
}',
  'headers' => [
    'Authorization' => 'Bearer <token>',
    'Content-Type' => 'application/json',
  ],
]);

echo $response->getBody();
```

```csharp
using RestSharp;

var client = new RestClient("https://tester.army/api/v1/projects/projectId/pull-request-runs");
var request = new RestRequest(Method.POST);
request.AddHeader("Authorization", "Bearer <token>");
request.AddHeader("Content-Type", "application/json");
request.AddParameter("application/json", "{\n  \"targetUrl\": \"string\",\n  \"pullRequest\": {\n    \"number\": 1,\n    \"title\": \"string\",\n    \"commitSha\": \"string\"\n  }\n}", ParameterType.RequestBody);
IRestResponse response = client.Execute(request);
```

```swift
import Foundation

let headers = [
  "Authorization": "Bearer <token>",
  "Content-Type": "application/json"
]
let parameters = [
  "targetUrl": "string",
  "pullRequest": [
    "number": 1,
    "title": "string",
    "commitSha": "string"
  ]
] as [String : Any]

let postData = JSONSerialization.data(withJSONObject: parameters, options: [])

let request = NSMutableURLRequest(url: NSURL(string: "https://tester.army/api/v1/projects/projectId/pull-request-runs")! as URL,
                                        cachePolicy: .useProtocolCachePolicy,
                                    timeoutInterval: 10.0)
request.httpMethod = "POST"
request.allHTTPHeaderFields = headers
request.httpBody = postData as Data

let session = URLSession.shared
let dataTask = session.dataTask(with: request as URLRequest, completionHandler: { (data, response, error) -> Void in
  if (error != nil) {
    print(error as Any)
  } else {
    let httpResponse = response as? HTTPURLResponse
    print(httpResponse)
  }
})

dataTask.resume()
```